mod client;
mod field;
mod queue;
// mod session;
mod utils;

use client::{Client, ClientLink, Reply, Request};
use field::Field;
use queue::Queue;

#[derive(Clone)]
pub struct MoreThanText {
    client_link: ClientLink,
}

impl MoreThanText {
    pub fn new() -> Self {
        let queue = Queue::new();
        Self {
            client_link: Client::start(queue.clone()),
        }
    }

    pub fn request<F>(&mut self, _session: Option<F>) -> Reply
    where
        F: Into<Field>,
    {
        let req = Request::new();
        let rx = self.client_link.send(req);
        rx.recv().unwrap()
    }
}
